package jp.gr.drl.utsugi.iouzima;

import java.util.Vector;

public class Spot {
	
	final int Spot_ID;
	final int SPOT_Y;
	final int SPOT_X;
	int syurui;
	boolean sonzai;
	// この場所にいるエージェントを保持する配列
	Vector<Agent> agents = new Vector<Agent>();
	
	
	/**
	 * エージェントを受け入れる
	 * 
	 * @param a
	 *            受け入れるエージェント
	 * @return 0：成功 -1；失敗
	 */
	int setAgent(Agent a) {
		/*
		 * エージェントの受け入れ 今のところは、Ｓｐｏｔにおけるエージェントの数に制限なし。
		 */
		if (agents.indexOf(a) != -1) {
			// エージェントがすでに存在
			System.out.println("class Spot " + Spot_ID + "エージェントがすでに存在しています。"
					+ a);
			return -1;
		} else {
			agents.add(a);
			a.setBasyo(Spot_ID, SPOT_Y, SPOT_X);
			return 0;// 成功したときは０をかえす
		}
	}
	
	boolean inAgent(int id) {
		for (int i = 0; i < agents.size(); i++) {
			if (agents.get(i).ID == id) {
				return true;
			}
		}
		return false;
	}
	
	int nomberOfAgent(int id) {
		for (int i = 0; i < agents.size(); i++) {
			if (agents.get(i).ID == id) {
				return i;
			}
		}
		return -1;
	}
	
	/**
	 * エージェントの抜き出し
	 * 
	 * @param id
	 *            抜き出すエージェントのID
	 * @return 抜き出すエージェント
	 */
	Agent putAgent(int id) {
		/*
		 * エージェントの抜き出し
		 */
		int no = nomberOfAgent(id);
		assert no >= 0 : "class Spot" + Spot_ID + "移動できませんでした。エージェントが存在しません。";
		return agents.remove(no);
	}
	
	/**
	 * コンストラクタ
	 * 
	 * @param id
	 *            エージェントID
	 * @param s
	 *            この場所が実際に存在するかどうかの値。<br>
	 *            0:存在しない<br>
	 *            1:存在する
	 * @param syu
	 *            スポットの種類
	 * 
	 */
	Spot(int id, int s, int syu, int y, int x) {
		Spot_ID = id;
		SPOT_Y = y;
		SPOT_X = x;
		syurui = syu;
		assert (s == 0 || s == 1) : "クラスSpot" + Spot_ID
				+ "：sに０と１以外の値が入力されています。";
		if (s == 0) {
			sonzai = false;
		} else if (s == 1) {
			sonzai = true;
		}
	}
}
